/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "ipsecconf/parser.y" /* yacc.c:339  */
   /* -*- bison-mode -*- */
/* Libreswan config file parser (parser.y)
 * Copyright (C) 2001 Mathieu Lafon - Arkoon Network Security
 * Copyright (C) 2004 Michael Richardson <mcr@sandelman.ottawa.on.ca>
 * Copyright (C) 2013 Paul Wouters <pwouters@redhat.com>
 * Copyright (C) 2013 Philippe Vouters <Philippe.Vouters@laposte.net>
 * Copyright (C) 2013 Antony Antony <antony@phenome.org>
 * Copyright (C) 2013 D. Hugh Redelmeier <hugh@mimosa.com>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <limits.h>
#include <unistd.h>
#include <errno.h>
#include <inttypes.h>
#define YYDEBUG 1

#include "deltatime.h"
#include "timescale.h"
#include "binaryscale-iec-60027-2.h"

#include "ipsecconf/keywords.h"
#include "ipsecconf/parser.h"	/* includes parser.tab.h" */
#include "ipsecconf/scanner.h"
#include "ipsecconf/confread.h"
#include "lswlog.h"
#include "lmod.h"
#include "sparse_names.h"
#include "lswalloc.h"

#define YYERROR_VERBOSE
#define ERRSTRING_LEN	256

static void parser_key_value_warning(struct parser *parser,
				     const struct ipsec_conf_keyval *key,
				     shunk_t value,
				     const char *s, ...) PRINTF_LIKE(4);

void parse_keyval(struct parser *parser, enum end default_end,
		  shunk_t key, shunk_t value);

static void yyerror(struct parser *parser, const char *msg);

static void append_parser_key_value(struct parser *parser,
				    struct ipsec_conf_keyval *key,
				    shunk_t value,
				    uintmax_t number,
				    deltatime_t deltatime);

static void add_parser_key_value(struct parser *parser,
				 struct ipsec_conf_keyval *key,
				 shunk_t value,
				 uintmax_t number,
				 deltatime_t time);

/**
 * Functions
 */


#line 141 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.tab.h".  */
#ifndef YY_YY_OBJ_LINUX_X86_64_LIB_LIBSWAN_IPSECCONF_PARSER_TAB_H_INCLUDED
# define YY_YY_OBJ_LINUX_X86_64_LIB_LIBSWAN_IPSECCONF_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    EQUAL = 258,
    FIRST_SPACES = 259,
    EOL = 260,
    CONFIG = 261,
    SETUP = 262,
    CONN = 263,
    INCLUDE = 264,
    VERSION = 265,
    STRING = 266,
    KEYWORD = 267,
    COMMENT = 268
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 78 "ipsecconf/parser.y" /* yacc.c:355  */

	char *s;

#line 199 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (struct parser *parser);

#endif /* !YY_YY_OBJ_LINUX_X86_64_LIB_LIBSWAN_IPSECCONF_PARSER_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 216 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   29

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  14
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  11
/* YYNRULES -- Number of rules.  */
#define YYNRULES  23
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  38

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   268

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint8 yyrline[] =
{
       0,    91,    91,    96,    97,   103,   104,   107,   108,   112,
     112,   117,   117,   136,   143,   144,   147,   148,   151,   165,
     173,   179,   185,   190
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "EQUAL", "FIRST_SPACES", "EOL", "CONFIG",
  "SETUP", "CONN", "INCLUDE", "VERSION", "STRING", "KEYWORD", "COMMENT",
  "$accept", "config_file", "versionstmt", "blanklines", "sections",
  "section_or_include", "$@1", "$@2", "kw_sections", "kw_section",
  "statement_kw", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268
};
# endif

#define YYPACT_NINF -13

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-13)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -13,     4,    -4,   -13,   -13,    -6,   -13,     5,     6,   -13,
       9,     7,     8,   -13,    12,    15,    16,    17,    12,   -13,
     -13,   -13,   -13,   -13,    19,    19,    -5,   -13,   -13,    21,
      22,    23,    -9,    18,   -13,   -13,   -13,   -13
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       5,     0,     3,     1,     6,     0,     7,     0,     2,     5,
       0,     0,     0,     5,     4,     0,     0,     0,     8,     9,
      11,    13,    14,    14,    10,    12,     0,    15,    17,     0,
      23,     0,    20,    22,    16,    19,    18,    21
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -13,   -13,   -13,     0,   -13,   -13,   -13,   -13,   -12,   -13,
     -13
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     6,     2,     8,    13,    22,    23,    24,    27,
      31
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      28,     4,    35,    36,     3,     7,     5,    29,    30,    14,
       9,    25,    10,    18,    11,    12,    15,     4,    16,    17,
      19,    20,    21,    26,    32,    33,     0,     0,    34,    37
};

static const yytype_int8 yycheck[] =
{
       5,     5,    11,    12,     0,    11,    10,    12,    13,     9,
       5,    23,     6,    13,     8,     9,     7,     5,    11,    11,
       5,     5,     5,     4,     3,     3,    -1,    -1,     5,    11
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    15,    17,     0,     5,    10,    16,    11,    18,     5,
       6,     8,     9,    19,    17,     7,    11,    11,    17,     5,
       5,     5,    20,    21,    22,    22,     4,    23,     5,    12,
      13,    24,     3,     3,     5,    11,    12,    11
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    14,    15,    16,    16,    17,    17,    18,    18,    20,
      19,    21,    19,    19,    22,    22,    23,    23,    24,    24,
      24,    24,    24,    24
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     0,     4,     0,     2,     0,     3,     0,
       5,     0,     5,     3,     0,     2,     3,     2,     3,     3,
       2,     3,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (parser, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, parser); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, struct parser *parser)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (parser);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, struct parser *parser)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, parser);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, struct parser *parser)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , parser);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, parser); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, struct parser *parser)
{
  YYUSE (yyvaluep);
  YYUSE (parser);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (struct parser *parser)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (parser);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 97 "ipsecconf/parser.y" /* yacc.c:1646  */
    {
		/* free strings allocated by lexer */
		pfreeany((yyvsp[-2].s));
	}
#line 1312 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 112 "ipsecconf/parser.y" /* yacc.c:1646  */
    {
		parser->keyvals = &parser->cfg->config_setup;
		parser->section = SECTION_CONFIG_SETUP;
		ldbg(parser->logger, "reading config setup");
	}
#line 1322 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 117 "ipsecconf/parser.y" /* yacc.c:1646  */
    {
		struct section_list *section = alloc_thing(struct section_list, "section list");
		PASSERT(parser->logger, section != NULL);

		section->name = clone_str((yyvsp[-1].s), "section->name");
		TAILQ_INIT(&section->keyvals);
		TAILQ_INSERT_TAIL(&parser->cfg->sections, section, next);

		/* setup keyword section to record values */
		parser->keyvals = &section->keyvals;
		parser->section = (streq(section->name, "%default") ? SECTION_CONN_DEFAULT :
				   SECTION_CONN);

		ldbg(parser->logger, "reading conn %s", section->name);

		/* free strings allocated by lexer */
		pfreeany((yyvsp[-1].s));

	}
#line 1346 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 136 "ipsecconf/parser.y" /* yacc.c:1646  */
    {
		scanner_include((yyvsp[-1].s), parser);
		/* free strings allocated by lexer */
		pfreeany((yyvsp[-1].s))
	}
#line 1356 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 151 "ipsecconf/parser.y" /* yacc.c:1646  */
    {
		/*
		 * Because the third argument was also a keyword, we
		 * dig up the string representation.
		 *
		 * There should be a way to stop the lexer converting
		 * the third field into a keyword.
		 */
		char *key = (yyvsp[-2].s); /* must free? */
		char *value = (yyvsp[0].s); /* must free */
		parse_keyval(parser, END_ROOF, shunk1(key), shunk1(value));
		pfreeany(key);
		pfreeany(value);
	}
#line 1375 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 165 "ipsecconf/parser.y" /* yacc.c:1646  */
    {
		char *key = (yyvsp[-2].s);
		char *value = (yyvsp[0].s);
		parse_keyval(parser, END_ROOF, shunk1(key), shunk1(value));
		/* free strings allocated by lexer */
		pfreeany(key);
		pfreeany(value);
	}
#line 1388 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 173 "ipsecconf/parser.y" /* yacc.c:1646  */
    {
		char *key = (yyvsp[-1].s);
		parse_keyval(parser, END_ROOF, shunk1(key), shunk1(""));
		pfreeany(key);
	}
#line 1398 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 179 "ipsecconf/parser.y" /* yacc.c:1646  */
    {
		parser_warning(parser, 0/*error*/, "X- style comment ignored: %s=%s", (yyvsp[-2].s), (yyvsp[0].s));
		/* free strings allocated by lexer */
		pfreeany((yyvsp[-2].s));
		pfreeany((yyvsp[0].s));
	}
#line 1409 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 185 "ipsecconf/parser.y" /* yacc.c:1646  */
    {
		parser_warning(parser, 0/*error*/, "X- style comment ignored: %s=", (yyvsp[-1].s));
		/* free strings allocated by lexer */
		pfreeany((yyvsp[-1].s));
	}
#line 1419 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 190 "ipsecconf/parser.y" /* yacc.c:1646  */
    {
		parser_warning(parser, 0/*error*/, "X- style comment ignored: %s", (yyvsp[0].s));
		/* free strings allocated by lexer */
		pfreeany((yyvsp[0].s));
	}
#line 1429 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:1646  */
    break;


#line 1433 "../../OBJ.linux.x86_64/lib/libswan/ipsecconf/parser.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (parser, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (parser, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, parser);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, parser);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (parser, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, parser);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, parser);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 196 "ipsecconf/parser.y" /* yacc.c:1906  */


void parser_warning(struct parser *parser, int error, const char *s, ...)
{
	if (parser->error_stream != NO_STREAM) {
		LLOG_JAMBUF(parser->error_stream, parser->logger, buf) {
			jam_scanner_file_line(buf, parser);
			jam_string(buf, "warning: ");
			va_list ap;
			va_start(ap, s);
			jam_va_list(buf, s, ap);
			va_end(ap);
			if (error > 0) {
				jam_errno(buf, error);
			}
		}
	}
}

void parser_fatal(struct parser *parser, int error, const char *s, ...)
{
	LLOG_FATAL_JAMBUF(PLUTO_EXIT_FAIL, parser->logger, buf) {
		jam_scanner_file_line(buf, parser);
		va_list ap;
		va_start(ap, s);
		jam_va_list(buf, s, ap);
		va_end(ap);
		if (error > 0) {
			jam_errno(buf, error);
		}
        }
	abort(); /* gcc doesn't believe above always exits */
}

static const char *leftright(const struct ipsec_conf_keyval *keyval)
{
	if (keyval->left && !keyval->right) {
		return "left";
	}
	if (!keyval->left && keyval->right) {
		return "right";
	}
	return "";
}

/*
 * Note: VALUE hasn't yet been copied into KEY.
 */

void parser_key_value_warning(struct parser *parser,
			      const struct ipsec_conf_keyval *key,
			      shunk_t value,
			      const char *s, ...)
{
	if (parser->error_stream != NO_STREAM) {
		LLOG_JAMBUF(parser->error_stream, parser->logger, buf) {
			jam(buf, PRI_KEYVAL_SAL": ", pri_keyval_sal(key));
			jam_string(buf, "warning: ");
			/* message */
			va_list ap;
			va_start(ap, s);
			jam_va_list(buf, s, ap);
			va_end(ap);
			/* what was specified */
			jam_string(buf, ": ");
			jam_string(buf, leftright(key));
			jam_string(buf, key->key->keyname);
			jam_string(buf, "=");
			jam_shunk(buf, value);
		}
	}
}

void yyerror(struct parser *parser, const char *s)
{
	if (parser->error_stream != NO_STREAM) {
		LLOG_JAMBUF(parser->error_stream, parser->logger, buf) {
			jam_scanner_file_line(buf, parser);
			jam_string(buf, s);
		}
	}
}

static struct ipsec_conf *alloc_ipsec_conf(void)
{
	struct ipsec_conf *cfgp = alloc_thing(struct ipsec_conf, __func__);
	TAILQ_INIT(&cfgp->config_setup);
	TAILQ_INIT(&cfgp->sections);
	TAILQ_INIT(&cfgp->sources);
	return cfgp;
}

struct ipsec_conf *load_ipsec_conf(const char *file,
				   struct logger *logger,
				   bool setuponly,
				   unsigned verbosity)
{
	struct parser parser = {
		.logger = logger,
		.error_stream = ERROR_STREAM,
		.verbosity = verbosity,
		.setuponly = setuponly,
		.cfg = alloc_ipsec_conf(),
	};

	if (!scanner_open(&parser, file)) {
		pfree_ipsec_conf(&parser.cfg);
		return NULL;
	}

	if (yyparse(&parser) != 0) {
		/* suppress errors */
		parser.error_stream = (LDBGP(DBG_BASE, logger) ? DEBUG_STREAM : NO_STREAM);
		do {} while (yyparse(&parser) != 0);
		pfree_ipsec_conf(&parser.cfg);
		scanner_close(&parser);
		return NULL;
	}

	scanner_close(&parser);

	/**
	 * Config valid
	 */
	return parser.cfg;
}

struct ipsec_conf *argv_ipsec_conf(const char *name, char *argv[], int start,
				   struct logger *logger)
{
	struct parser parser = {
		.cfg = alloc_ipsec_conf(),
		.logger = logger,
		.setuponly = false,
	};

	/*
	 * There's only section and it's a conn; fudge things up so
	 * that processing just started.
	 */

	struct section_list *section = alloc_thing(struct section_list, __func__);
	section->name = clone_str(name, __func__);
	TAILQ_INIT(&section->keyvals);
	TAILQ_INSERT_TAIL(&parser.cfg->sections, section, next);

	parser.section = SECTION_CONN;
	parser.keyvals = &section->keyvals,

	scanner_init(&parser, "argv", start);

	/* for options that should have an end, but don't */
	enum end default_end = LEFT_END;

	for (char **argp = argv + start; (*argp) != NULL; argp++) {

		const char *const arg = (*argp);
		shunk_t cursor = shunk1(arg);

		/* only whack options have -- */
		bool whack = hunk_streat(&cursor, "--");

		/*
		 * Parse simple whack --OPTIONs (remember leading "--"
		 * indicating a whack option was stripped and WHACK
		 * set).
		 */

		if (whack && hunk_streq(cursor, "to")) {
			default_end++;
			if (default_end >= END_ROOF) {
				llog(ERROR_STREAM, logger, "too many '--to's");
				pfree_ipsec_conf(&parser.cfg);
				exit(1);
			}
			scanner_next_line(&parser);
			continue;
		}

		if (whack && hunk_streat(&cursor, "nego")) {
			parse_keyval(&parser, default_end,
				     shunk1("negotiationshunt"),
				     cursor);
			scanner_next_line(&parser);
			continue;
		}

		if (whack && hunk_streat(&cursor, "fail")) {
			parse_keyval(&parser, default_end,
				     shunk1("failureshunt"),
				     cursor);
			scanner_next_line(&parser);
			continue;
		}

		/*
		 * Parse KEY=VALUE (and --KEY=VALUE).  When whack,
		 * also allow --KEY VALUE.
		 */

		char sep;
		shunk_t key = shunk_token(&cursor, &sep, "=");
		shunk_t value;
		if (sep == '=') {
			value = cursor;
		} else if (whack) {
			/* only allow --KEY VALUE when whack compat */
			if (argp[1] == NULL) {
				llog(ERROR_STREAM, logger, "missing argument for %s", arg);
				pfree_ipsec_conf(&parser.cfg);
				return NULL;
			}
			/* skip/use next arg */
			argp++;
			value = shunk1(*argp);
			scanner_next_line(&parser);
		} else {
			llog(ERROR_STREAM, logger, "missing '=' in %s", arg);
			pfree_ipsec_conf(&parser.cfg);
			exit(1);
		}

		/*
		 * Handle whack --KEY=VALUE options by mapping the KEY
		 * onto the equivalent ipsec.conf KEY.
		 */

		if (whack && hunk_streq(key, "host")) {
			key = shunk1(default_end == LEFT_END ? "left" :
				     default_end == RIGHT_END ? "right" :
				     "???");
		}

		if (whack && hunk_streq(key, "authby")) {
			/* XXX: whack's authby semantics */
			key = shunk1("auth");
		}

		parse_keyval(&parser, default_end, key, value);
		scanner_next_line(&parser);
	}

	scanner_close(&parser);

	return parser.cfg;
}

static void pfree_keyval_list(struct keyval_list *list)
{
	struct keyval_entry *head;
	while ((head = TAILQ_FIRST(list)) != NULL) {
		TAILQ_REMOVE(list, head, next);
		pfreeany(head->keyval.val);
		pfree(head);
	}
}

const char *add_ipsec_conf_source(struct ipsec_conf *cfg, const char *name)
{
	struct ipsec_conf_source *source = alloc_thing(struct ipsec_conf_source, __func__);
	source->name = clone_str(name, __func__);
	TAILQ_INSERT_TAIL(&cfg->sources, source, next);
	return source->name;
}

void pfree_ipsec_conf(struct ipsec_conf **cfgp)
{
	if ((*cfgp) != NULL) {
		struct ipsec_conf *cfg = (*cfgp);
		pfree_keyval_list(&cfg->config_setup);

		/* keep deleting the first entry */
		struct section_list *section;
		while ((section = TAILQ_FIRST(&cfg->sections)) != NULL) {
			TAILQ_REMOVE(&cfg->sections, section, next);
			pfreeany(section->name);
			pfree_keyval_list(&section->keyvals);
			pfree(section);
		}

		/* keep deleting the first entry */
		struct ipsec_conf_source *source;
		while ((source = TAILQ_FIRST(&cfg->sources)) != NULL) {
			TAILQ_REMOVE(&cfg->sources, source, next);
			pfreeany(source->name);
			pfreeany(source);
		}

		pfreeany(*cfgp);
	}
}

void add_parser_key_value(struct parser *parser,
			  struct ipsec_conf_keyval *key,
			  shunk_t value,
			  uintmax_t number,
			  deltatime_t deltatime)
{
	/* both means no prefix */
	const char *section = str_parser_section(parser);

	/* Find end, while looking for duplicates. */
	struct keyval_entry *kv;
	TAILQ_FOREACH(kv, parser->keyvals, next) {
		if (kv->keyval.key != key->key) {
			continue;
		}
		if ((kv->keyval.left != key->left) &&
		    (kv->keyval.right != key->right)) {
			continue;
		}
		if (key->key->validity & kv_duplicateok) {
			continue;
		}
		/* note the weird behaviour! */
		if (parser->section == SECTION_CONFIG_SETUP) {
			parser_key_value_warning(parser, key, value,
						 "overriding earlier '%s' keyword with new value", section);
			pfreeany(kv->keyval.val);
			kv->keyval.val = clone_hunk_as_string(value, "keyword.string"); /*handles NULL*/
			kv->number = number;
			kv->deltatime = deltatime;
			return;
		}
		parser_key_value_warning(parser, key, value,
					 "ignoring duplicate %s keyword", section);
		return;
	}

	append_parser_key_value(parser, key, value, number, deltatime);
}

static void append_parser_key_value(struct parser *parser,
				    struct ipsec_conf_keyval *key,
				    shunk_t value,
				    uintmax_t number,
				    deltatime_t deltatime)
{
	/*
	 * fill the values into new
	 * (either string or number might have a placeholder value
	 */
	struct keyval_entry *new = alloc_thing(struct keyval_entry, "kw_list");
	(*new) = (struct keyval_entry) {
		.keyval = *key,
		.number = number,
		.deltatime = deltatime,
	};

	/* add the value */
	new->keyval.val = clone_hunk_as_string(value, /*handles NULL*/
					       "keyword.list");

	if (LDBGP(DBG_TMI, parser->logger)) {
		LLOG_JAMBUF(DEBUG_STREAM, parser->logger, buf) {
			jam(buf, "  %s%s=%s", leftright(key),
			    key->key->keyname, new->keyval.val);
			jam(buf, " number=%ju", new->number);
			jam(buf, " field=%u", key->key->field);
			jam_string(buf, " deltatime=");
			jam_deltatime(buf, new->deltatime);
		}
	}

	/* append the new kw_list to the list */
	TAILQ_INSERT_TAIL(parser->keyvals, new, next);
}

diag_t parse_kt_unsigned(const struct ipsec_conf_keyval *key UNUSED,
			 shunk_t value, uintmax_t *number)
{
	/* treat -1 as special, turning it into max */
	if (hunk_streq(value, "-1")) {
		(*number) = UINTMAX_MAX;
		return NULL;
	}

	err_t err = shunk_to_uintmax(value, NULL, /*base*/10, number);
	if (err == NULL) {
		return NULL;
	}

	return diag("%s", err);
}

diag_t parse_kt_deltatime(const struct ipsec_conf_keyval *key UNUSED,
			  shunk_t value, enum timescale default_timescale,
			  deltatime_t *deltatime)
{
	diag_t diag = ttodeltatime(value, deltatime, default_timescale);
	if (diag != NULL) {
		return diag;
	}

	return NULL;
}

diag_t parse_kt_sparse_name(const struct ipsec_conf_keyval *key,
			    shunk_t value, uintmax_t *number,
			    enum stream stream, struct logger *logger)
{
	const struct sparse_names *names = key->key->sparse_names;

	const struct sparse_name *sn = sparse_lookup_by_name(names, value);
	if (sn == NULL) {
		/*
		 * We didn't find anything, complain.
		 *
		 * XXX: call jam_sparse_names() to list what is valid?
		 */
		return diag("invalid");
	}

	(*number) = sn->value & ~NAME_FLAGS;

	if (stream != NO_STREAM) {
		enum name_flags flags = (sn->value & NAME_FLAGS);
		name_buf new_name;

		switch (flags) {
		case NAME_IMPLEMENTED_AS:
			llog(stream, logger, PRI_KEYVAL_SAL": warning: "PRI_SHUNK" implemented as %s: %s="PRI_SHUNK,
			     pri_keyval_sal(key),
			     pri_shunk(value), str_sparse_short(names, (*number), &new_name),
			     key->key->keyname, pri_shunk(value));
			return NULL;
		case NAME_RENAMED_TO:
			llog(stream, logger, PRI_KEYVAL_SAL": warning: "PRI_SHUNK" renamed to %s: %s="PRI_SHUNK,
			     pri_keyval_sal(key),
			     pri_shunk(value), str_sparse_short(names, (*number), &new_name),
			     key->key->keyname, pri_shunk(value));
			return NULL;
		}
	}

	return NULL;
}

/*
 * Look for one of the tokens, and set the value up right.
 */

static bool parse_leftright(shunk_t s,
			    const struct keyword_def *k,
			    const char *leftright)
{
	/* gobble up "left|right" */
	if (!hunk_strcaseeat(&s, leftright)) {
		return false;
	}

	/* if present and kw non-empty, gobble up "-" */
	if (strlen(k->keyname) > 0) {
		hunk_streat(&s, "-");
	}

	/* keyword matches? */
	if (!hunk_strcaseeq(s, k->keyname)) {
		return false;
	}

	/* success */
	return true;
}

/* type is really "token" type, which is actually int */
static bool parser_find_key(shunk_t skey, enum end default_end,
			    struct ipsec_conf_keyval *key,
			    struct parser *parser)
{
	bool left = false;
	bool right = false;

	zero(key);

	const struct keywords_def *keywords =
		(parser->section == SECTION_CONFIG_SETUP ? &config_setup_keywords :
		 &config_conn_keywords);

	const struct keyword_def *found = NULL;
	ITEMS_FOR_EACH(k, keywords) {

		if (k->keyname == NULL) {
			continue;
		}

		if (k->validity & kv_ignore) {
			continue;
		}

		if (parser->section == SECTION_CONN_DEFAULT &&
		    k->field == KSCF_ALSO) {
			continue;
		}

		if (hunk_strcaseeq(skey, k->keyname)) {

			/*
			 * Given a KEY with BOTH|LEFTRIGHT, BOTH
			 * trumps LEFTRIGHT.
			 *
			 * For instance:
			 *
			 *   --key=value --to ...
			 *
			 * sets left-key and right-key.  To only set
			 * one end, specify:
			 *
			 *   --right-key=value --to ...
			 *
			 */
			if (k->validity & kv_both) {
				left = true;
				right = true;
				found = k;
				break;
			}

			/*
			 * For instance --auth=... --to ...
			 */
			if (k->validity & kv_leftright) {
				if (default_end == LEFT_END) {
					left = true;
					found = k;
					break;
				}
				if (default_end == RIGHT_END) {
					right = true;
					found = k;
					break;
				}

#if 0 /* see github#663 */
				continue;
#else
				parser_warning(parser, 0, "%s= is being treated as right-%s=",
					       k->keyname, k->keyname);
				right = true;
#endif
			}
			found = k;
			break;
		}

		if (k->validity & kv_leftright) {
			left = parse_leftright(skey, k, "left");
			if (left) {
				found = k;
				break;
			}
			right = parse_leftright(skey, k, "right");
			if (right) {
				found = k;
				break;
			}
		}
	}

	/* if we still found nothing */
	if (found == NULL) {
		parser_fatal(parser, /*errno*/0, "unrecognized '%s' keyword '"PRI_SHUNK"'",
			     str_parser_section(parser), pri_shunk(skey));
		/* never returns */
		return false;
	}

	/* else, set up llval.k to point, and return KEYWORD */
	key->key = found;
	key->left = left;
	key->right = right;
	key->val = NULL; /* later */
	key->sal = scanner_sal(parser);
	return true;
}

void parse_keyval(struct parser *parser, enum end default_end,
		  shunk_t skey, shunk_t value)
{
	struct ipsec_conf_keyval key;
	if (!parser_find_key(skey, default_end, &key, parser)) {
		return;
	}

	/* fill in once look succeeds */
	PEXPECT(parser->logger, key.val == NULL);

	if (parser->section == SECTION_CONFIG_SETUP) {
		/*
		 * Throw everything onto the end of the list:
		 *
		 * Note: this includes kt_obsolete keyvalues.
		 * Note: this includes duplicate keywords.
		 */
		append_parser_key_value(parser, &key, value, 0, (deltatime_t){0});
		return;
	}


	uintmax_t number = 0;		/* neutral placeholding value */
	deltatime_t deltatime = {.is_set = false, };
	diag_t d = NULL;

	switch (key.key->type) {

	case kt_sparse_name:
		d = parse_kt_sparse_name(&key, value, &number,
					 parser->error_stream,
					 parser->logger);
		break;

	case kt_string:
	case kt_also:
	case kt_appendstring:
	case kt_appendlist:
		break;

	case kt_unsigned:
		d = parse_kt_unsigned(&key, value, &number);
		break;

	case kt_seconds:
		d = parse_kt_deltatime(&key, value, TIMESCALE_SECONDS, &deltatime);
		break;

	case kt_obsolete:
		/* drop it on the floor */
		parser_key_value_warning(parser, &key, value, "obsolete keyword ignored");
		return;

	}

	if (d != NULL) {
		llog(RC_LOG, parser->logger,
		     PRI_KEYVAL_SAL": warning: %s, keyword ignored: %s%s="PRI_SHUNK,
		     pri_keyval_sal(&key), str_diag(d),
		     leftright(&key), key.key->keyname, pri_shunk(value));
		pfree_diag(&d);
		return;
	}

	add_parser_key_value(parser, &key, value, number, deltatime);
}
